aboutsummaryrefslogtreecommitdiff
diff options
context:
space:
mode:
-rwxr-xr-x.config/herbstluftwm/autostart187
1 files changed, 187 insertions, 0 deletions
diff --git a/.config/herbstluftwm/autostart b/.config/herbstluftwm/autostart
new file mode 100755
index 0000000..3264c0b
--- /dev/null
+++ b/.config/herbstluftwm/autostart
@@ -0,0 +1,187 @@
+#!/usr/bin/env bash
+
+# this is a simple config for herbstluftwm
+
+hc() {
+ herbstclient "$@"
+}
+
+hc emit_hook reload
+
+xsetroot -solid '#5A8E3A'
+
+# remove all existing keybindings
+hc keyunbind --all
+
+# keybindings
+# if you have a super key you will be much happier with Mod set to Mod4
+myModA=Mod4 # Use the super key as the main modifier
+myModB=Mod1 # Use alt as the main modifier
+
+hc keybind $myModA-Shift-q quit
+hc keybind $myModA-Shift-r reload
+hc keybind $myModB-w close
+hc keybind $myModA-Return spawn prime-run alacritty
+hc keybind $myModA-Shift-p spawn dmenu_run
+
+# basic movement in tiling and floating mode
+# focusing clients
+hc keybind $myModA-Left focus left
+hc keybind $myModA-Down focus down
+hc keybind $myModA-Up focus up
+hc keybind $myModA-Right focus right
+hc keybind $myModA-h focus left
+hc keybind $myModA-j focus down
+hc keybind $myModA-k focus up
+hc keybind $myModA-l focus right
+
+# moving clients in tiling and floating mode
+hc keybind $myModA-Shift-Left shift left
+hc keybind $myModA-Shift-Down shift down
+hc keybind $myModA-Shift-Up shift up
+hc keybind $myModA-Shift-Right shift right
+hc keybind $myModA-Shift-h shift left
+hc keybind $myModA-Shift-j shift down
+hc keybind $myModA-Shift-k shift up
+hc keybind $myModA-Shift-l shift right
+
+# splitting frames
+# create an empty frame at the specified direction
+hc keybind $myModA-Control-h split left 0.5
+hc keybind $myModA-Control-j split bottom 0.5
+hc keybind $myModA-Control-k split top 0.5
+hc keybind $myModA-Control-l split right 0.5
+# let the current frame explode into subframes
+hc keybind $myModA-Control-space split explode
+
+# resizing frames and floating clients
+resizestep=0.01
+hc keybind $myModA-$myModB-h resize left +$resizestep
+hc keybind $myModA-$myModB-j resize down +$resizestep
+hc keybind $myModA-$myModB-k resize up +$resizestep
+hc keybind $myModA-$myModB-l resize right +$resizestep
+hc keybind $myModA-$myModB-Left resize left +$resizestep
+hc keybind $myModA-$myModB-Down resize down +$resizestep
+hc keybind $myModA-$myModB-Up resize up +$resizestep
+hc keybind $myModA-$myModB-Right resize right +$resizestep
+
+# tags
+tag_names=( {1..9} )
+tag_keys=( {1..9} 0 )
+
+hc rename default "${tag_names[0]}" || true
+for i in "${!tag_names[@]}" ; do
+ hc add "${tag_names[$i]}"
+ key="${tag_keys[$i]}"
+ if ! [ -z "$key" ] ; then
+ hc keybind "$myModA-$key" use_index "$i"
+ hc keybind "$myModA-Shift-$key" move_index "$i"
+ fi
+done
+
+# cycle through tags
+hc keybind $myModB-l use_index +1 --skip-visible
+hc keybind $myModB-h use_index -1 --skip-visible
+
+# layouting
+hc keybind $myModA-d remove
+hc keybind $myModA-a floating toggle
+hc keybind $myModA-f fullscreen toggle
+hc keybind $myModA-Shift-a set_attr clients.focus.floating toggle
+hc keybind $myModA-Control-a set_attr clients.focus.minimized true
+hc keybind $myModA-Control-Shift-a jumpto last-minimized
+hc keybind $myModA-Control-F pseudotile toggle
+# The following cycles through the available layouts within a frame, but skips
+# layouts, if the layout change wouldn't affect the actual window positions.
+# I.e. if there are two windows within a frame, the grid layout is skipped.
+hc keybind $myModA-space \
+ or , and . compare tags.focus.curframe_wcount = 2 \
+ . cycle_layout +1 vertical horizontal max vertical grid \
+ , cycle_layout +1
+
+# mouse
+hc mouseunbind --all
+hc mousebind $myModA-Button1 move
+hc mousebind $myModA-Button2 zoom
+hc mousebind $myModA-Button3 resize
+
+# focus
+hc keybind $myModA-BackSpace cycle_monitor
+hc keybind $myModB-j cycle_all -1
+hc keybind $myModB-k cycle_all +1
+hc keybind $myModA-i jumpto urgent
+
+# theme
+hc attr theme.tiling.reset 1
+hc attr theme.floating.reset 1
+hc set frame_border_active_color '#37AFA7'
+hc set frame_border_normal_color '#1D645F'
+hc set frame_bg_normal_color '#00000000'
+hc set frame_bg_active_color '#00000000'
+hc set frame_border_width 3
+hc set always_show_frame on
+hc set frame_bg_transparent off
+hc set frame_transparent_width 0
+hc set frame_gap 4
+
+hc attr theme.title_height 0
+# hc attr theme.title_font 'Dejavu Sans:pixelsize=12' # example using Xft
+# hc attr theme.title_font '-*-fixed-medium-r-*-*-13-*-*-*-*-*-*-*'
+hc attr theme.padding_top 0 # space below the title's baseline (i.e. text depth)
+hc attr theme.active.color '#BF00FF'
+# hc attr theme.title_color '#ffffff'
+hc attr theme.normal.color '#323232dd'
+hc attr theme.urgent.color '#7811A1dd'
+# hc attr theme.normal.title_color '#898989'
+hc attr theme.inner_width 0
+hc attr theme.inner_color black
+hc attr theme.border_width 2
+hc attr theme.floating.border_width 4
+hc attr theme.floating.outer_width 0
+hc attr theme.floating.outer_color black
+hc attr theme.active.inner_color '#BF00FF'
+hc attr theme.urgent.inner_color '#9A65B000'
+hc attr theme.normal.inner_color '#130F23'
+# copy inner color to outer_color
+for state in active urgent normal ; do
+ hc substitute C theme.${state}.inner_color \
+ attr theme.${state}.outer_color C
+done
+hc attr theme.active.outer_width 1
+hc attr theme.background_color '#141414'
+
+hc set window_gap 6
+hc set frame_padding 4
+hc set smart_window_surroundings on
+hc set smart_frame_surroundings on
+hc set mouse_recenter_gap 0
+
+# rules
+hc unrule -F
+#hc rule class=XTerm tag=3 # move all xterms to tag 3
+hc rule focus=on # normally focus new clients
+hc rule floatplacement=smart
+#hc rule focus=off # normally do not focus new clients
+# give focus to most common terminals
+#hc rule class~'(.*[Rr]xvt.*|.*[Tt]erm|Konsole)' focus=on
+hc rule windowtype~'_NET_WM_WINDOW_TYPE_(DIALOG|UTILITY|SPLASH)' floating=on
+hc rule windowtype='_NET_WM_WINDOW_TYPE_DIALOG' focus=on
+hc rule windowtype~'_NET_WM_WINDOW_TYPE_(NOTIFICATION|DOCK|DESKTOP)' manage=off
+
+hc set tree_style '╾│ ├└╼─┐'
+
+# unlock, just to be sure
+hc unlock
+
+# do multi monitor setup here, e.g.:
+# hc set_monitors 1280x1024+0+0 1280x1024+1280+0
+# or simply:
+# hc detect_monitors
+
+# find the panel
+panel=~/.config/herbstluftwm/panel.sh
+[ -x "$panel" ] || panel=/etc/xdg/herbstluftwm/panel.sh
+for monitor in $(hc list_monitors | cut -d: -f1) ; do
+ # start it on each monitor
+ "$panel" "$monitor" &
+done